module SlugLess

  String.class_eval do
    def to_slug
      text = self.dup
      transliterate(text)
      sanitize(text)
      remove_special_characters(text)
    end

    private

    def transliterate(text)
      # TODO: figure out how to make this so others can choose which
      # dictionaries to load or even load custom ones.
      substitute_characters(text)
    end

    def substitute_characters(text, char_table = SlugLess::LATIN_DIACRITICS1)
      characters_to_change = char_table.values
      slug_friendly_characters = char_table.keys

      characters_to_change.each_with_index do |set, idx|
        text.chars.each do |char|
          text.gsub!(char, slug_friendly_characters[idx]) if set.include?(char)
        end
      end

      text
    end

    def sanitize(text)
      text.downcase!
      text.gsub! ' ','-'
      text.gsub!(/-+/, '-')
      text.gsub!(/\A-|-\z/, '')
      text
    end

    def remove_special_characters(text)
      text.gsub!(/[^a-z0-9-]/, '')
      text
    end
  end

end